/****************************************************************************/
/*      Everything You Always Wanted to Know about Data Partitioning        */
/*                         but Were AfraId to Ask                           */
/*                            PASS Summit 2017                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                        Benefits of Data Partitioning                     */
/*                Different Indexing Strategies & Mixed Workload            */
/****************************************************************************/

/* Obviously the problem is "almost" solved in SQL Server 2016 where you can 
combine B-Tree and Columnstore indexes. However, it is much more complicated
in SQL Server prior 2016. */

set nocount on
go

-- Check execution plans:
set statistics time, io on

select  top 20 ZipCode, Sum(Amount)
from NonPartitionedDb.dbo.Orders 
where 
	WarehouseId = 1 and
	OrderDate >= '2017-08-01' 
group by ZipCode
order by Sum(Amount) desc


select  top 20 ZipCode, Sum(Amount)
from PartitionedDb.dbo.Orders 
where 
	WarehouseId = 1 and
	OrderDate >= '2017-08-01'
group by ZipCode
order by Sum(Amount) desc

set statistics time, io off
go






set statistics time, io on

select  top 20 ZipCode, Sum(Amount)
from NonPartitionedDb.dbo.Orders 
where OrderDate >= '2017-08-01' 
group by ZipCode
order by Sum(Amount) desc


select  top 20 ZipCode, Sum(Amount)
from PartitionedDb.dbo.OrdersWithCCI 
where OrderDate >= '2017-08-01'
group by ZipCode
order by Sum(Amount) desc

set statistics time, io off
go



set statistics time, io on

select  top 20 ZipCode, Sum(Amount)
from NonPartitionedDb.dbo.Orders 
where OrderDate >= '2017-01-01' and OrderDate < '2017-07-01'
group by ZipCode
order by Sum(Amount) desc


select  top 20 ZipCode, Sum(Amount)
from PartitionedDb.dbo.OrdersWithCCI 
where OrderDate >= '2017-01-01' and OrderDate < '2017-07-01'
group by ZipCode
order by Sum(Amount) desc

set statistics time, io off
go
