/****************************************************************************/
/*      Everything You Always Wanted to Know about Data Partitioning        */
/*                         but Were AfraId to Ask                           */
/*                            PASS Summit 2017                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                   Analyzing used space in the filegroups                 */
/****************************************************************************/

use NonPartitionedDB
go

select 
	name as [FileName]
	,physical_name as [Path]
	,convert(int,fileproperty(name,'SpaceUsed')) / 
		128.0 as [UsedSpaceMb]
from sys.database_files
where type_desc = 'ROWS';
go

use PartitionedDB
go

select 
	name as [FileName]
	,physical_name as [Path]
	,convert(int,fileproperty(name,'SpaceUsed')) / 
		128.0 as [UsedSpaceMb]
from sys.database_files
where type_desc = 'ROWS';
go

select 
	sum(convert(int,fileproperty(name,'SpaceUsed'))) / 
		128.0 as [Total UsedSpaceMb]
from sys.database_files
where type_desc = 'ROWS';
go
