/****************************************************************************/
/*      Everything You Always Wanted to Know about Data Partitioning        */
/*                         but Were AfraId to Ask                           */
/*                            PASS Summit 2017                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                        Benefits of Data Partitioning                     */
/*                           Partial Database Backup                        */
/****************************************************************************/
use master
go

/*
backup database [NonPartitionedDB] 
to disk = N'C:\DB\Backup\NonPartitionedDB.bak' with format, init,
name = N'NonPartitionedDB-Full Database Backup', 
skip, norewind, nounload, compression,  stats = 5;
go
*/

alter database PartitionedDB set single_user with rollback immediate;

alter database PartitionedDB modify filegroup OldOrders readonly;
alter database PartitionedDB modify filegroup CCIOrders readonly;

alter database PartitionedDB set multi_user
go

backup database PartitionedDB 
filegroup = 'OldOrders', filegroup = 'CCIOrders'
to disk = N'C:\DB\Backup\PartitionedDB-RO.bak' with format, init,
name = N'PartitionedDB-Read Only Filegroups', 
skip, norewind, nounload, compression,  stats = 5;
go

create table PartitionedDB.dbo.Dummy(Col int);
go

backup database PartitionedDB
read_write_filegroups 
to disk = N'C:\DB\Backup\PartitionedDB.bak' with format, init,
name = N'PartitionedDB-Full Database Backup', 
skip, norewind, nounload, compression,  stats = 5;
go

insert into PartitionedDB.dbo.Dummy(Col) values(1);
go

backup log PartitionedDB 
to disk = N'C:\DB\Backup\PartitionedDB.trn' with format, init, 
name = N'PartitionedDB-Log Backup', 
skip, norewind, nounload, compression,  stats = 5;
go

/* Restore */
alter database PartitionedDB set single_user with rollback immediate;
drop database PartitionedDB;
go

-- Step 1: R/W Filegrops
restore database PartitionedDB 
filegroup = 'Primary', filegroup = 'CurrentOrders', filegroup = 'RecentOrders'
from disk = N'C:\DB\Backup\PartitionedDB.bak' 
with file = 1,  
norecovery, nounload,  partial, stats = 5;
go

-- Step 2: Log
restore log PartitionedDB 
from disk = N'C:\DB\Backup\PartitionedDB.trn' 
with nounload, norecovery, stats = 10;

-- Step 3 (Optional): Recovery 
restore database PartitionedDB with recovery;
go

select file_id, name, state_desc, physical_name
from PartitionedDB.sys.database_files
go

select * from PartitionedDB.dbo.Dummy;
go

-- Step 4 (Optional): R/O filegroups
restore database PartitionedDB 
filegroup = 'OldOrders', filegroup = 'CCIOrders'
from disk = N'C:\DB\Backup\PartitionedDB-RO.bak'
with file = 1,  
RECOVERY,  nounload,  stats = 5;
go

select file_id, name, state_desc, physical_name
from PartitionedDB.sys.database_files
go

select top 1 * from PartitionedDB.dbo.Orders2017 order by OrderDate;
go
