/******************************************************************************/
/*        Everything You Always Wanted to Know about Data Partitioning        */
/*                           but Were AfraId to Ask                           */
/*                              PASS Summit 2017                              */
/*                                                                            */
/*                    Written by Dmitri V. Korotkevitch                       */
/*                        http://aboutsqlserver.com                           */
/*                          dk@aboutsqlserver.com                             */
/******************************************************************************/
/*                                Data Movement                               */
/*                               Move Data Files                              */
/*http://aboutsqlserver.com/2017/03/08/how-to-move-data-and-log-files-online/ */
/******************************************************************************/

select @@VERSION
go

use PartitioningExpress
go

select 
	db_name() as DBName
	,name as [FileName]
	,physical_name as [Path]
	,size / 128.0 as CurrentSizeMB
	,size / 128.0 - convert(int,fileproperty(name,'SpaceUsed')) / 128.0 as FreeSpaceMb
from	
	sys.database_files
go    

USE [master]
GO

ALTER DATABASE PartitioningExpress 
ADD FILE 
( 
	NAME = N'PartitioningExpress_FG2017_File2', 
	FILENAME = N'c:\sqlexpress\drive2\PartitioningExpress_FG2017_File2.ndf', 
	SIZE = 100MB , 
	FILEGROWTH = 51200KB 
) TO FILEGROUP [FG2017]
GO

use PartitioningExpress
go

select 
	db_name() as DBName
	,name as [FileName]
	,physical_name as [Path]
	,size / 128.0 as CurrentSizeMB
	,size / 128.0 - convert(int,fileproperty(name,'SpaceUsed')) / 128.0 as FreeSpaceMb
from	
	sys.database_files
go    


dbcc shrinkfile(PartitioningExpress_FG2017, emptyfile)
go

alter database PartitioningExpress remove file PartitioningExpress_FG2017
go

select 
	db_name() as DBName
	,name as [FileName]
	,physical_name as [Path]
	,size / 128.0 as CurrentSizeMB
	,size / 128.0 - convert(int,fileproperty(name,'SpaceUsed')) / 128.0 as FreeSpaceMb
from	
	sys.database_files
go

