/****************************************************************************/
/*      Everything You Always Wanted to Know about Data Partitioning        */
/*                         but Were AfraId to Ask                           */
/*                            PASS Summit 2017                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                        Going Beyond B-Tree                               */
/*                            Creating SPs                                  */
/****************************************************************************/

set nocount on
set xact_abort on
go

use InMemoryOLTP2016
go

drop proc if exists dbo.InsertPayments2017_11;
drop proc if exists dbo.UpdatePayments2017_11;
drop proc if exists dbo.DeletePayments2017_11;
drop proc if exists dbo.InsertPayments2017_10;
drop proc if exists dbo.UpdatePayments2017_10;
drop proc if exists dbo.DeletePayments2017_10;
go

create proc dbo.InsertPayments2017_11
(
	@PaymentDate datetime2(0) not null
	,@CustomerId int not null
	,@Amount money not null
	,@Status tinyint not null
	,@PaymentId uniqueidentifier output
)
with native_compilation, schemabinding, execute as owner
as
begin atomic with
(
    transaction isolation level = snapshot
    ,language = N'English'
)
	set @PaymentId = NewId();

	insert into dbo.Payments2017_11(PaymentDate,PaymentId,CustomerId,Amount,Status)
	values(@PaymentDate, @PaymentId,@CustomerId,@Amount,@Status);
end
go

create proc dbo.UpdatePayments2017_11
(
	@PaymentDate datetime2(0) not null
	,@PaymentId uniqueidentifier not null
	,@Amount money not null
	,@Status tinyint not null
)
with native_compilation, schemabinding, execute as owner
as
begin atomic with
(
    transaction isolation level = snapshot
    ,language = N'English'
)
	update dbo.Payments2017_11
	set Amount = @Amount, @Status = @Status
	where PaymentId = @PaymentId
end
go

create proc dbo.DeletePayments2017_11
(
	@PaymentDate datetime2(0) not null
	,@PaymentId uniqueidentifier not null
)
with native_compilation, schemabinding, execute as owner
as
begin atomic with
(
    transaction isolation level = snapshot
    ,language = N'English'
)
	delete from dbo.Payments2017_11
	where PaymentId = @PaymentId;
end
go

create proc dbo.InsertPayments2017_10
(
	@PaymentDate datetime2(0) not null
	,@CustomerId int not null
	,@Amount money not null
	,@Status tinyint not null
	,@PaymentId uniqueidentifier output
)
with native_compilation, schemabinding, execute as owner
as
begin atomic with
(
    transaction isolation level = snapshot
    ,language = N'English'
)
	set @PaymentId = NewId();

	insert into dbo.Payments2017_10(PaymentDate,PaymentId,CustomerId,Amount,Status)
	values(@PaymentDate, @PaymentId,@CustomerId,@Amount,@Status);
end
go

create proc dbo.UpdatePayments2017_10
(
	@PaymentDate datetime2(0) not null
	,@PaymentId uniqueidentifier not null
	,@Amount money not null
	,@Status tinyint not null
)
with native_compilation, schemabinding, execute as owner
as
begin atomic with
(
    transaction isolation level = snapshot
    ,language = N'English'
)
	update dbo.Payments2017_10
	set Amount = @Amount, @Status = @Status
	where PaymentId = @PaymentId
end
go

create proc dbo.DeletePayments2017_10
(
	@PaymentDate datetime2(0) not null
	,@PaymentId uniqueidentifier not null
)
with native_compilation, schemabinding, execute as owner
as
begin atomic with
(
    transaction isolation level = snapshot
    ,language = N'English'
)
	delete from dbo.Payments2017_10
	where PaymentId = @PaymentId;
end
go
