-- Run with sqlcmd
set nocount on
go

use InMemoryOLTP2016
go

declare
	@PaymentDate datetime2(0) 
	,@CustomerId int
	,@Amount money 
	,@Status tinyint 
	,@PaymentId uniqueidentifier
	,@I int = 1

while 1 = 1
begin
	begin try
		;with CTE(PaymentDate, PaymentId, RowNum)
		as
		(
			select PaymentDate, PaymentId, ROW_NUMBER() over (order by PaymentDate)
			from dbo.Payments2017_10
		)
		select @PaymentDate = PaymentDate, @PaymentId = PaymentId
		from CTE
		where RowNum = @I;

		exec dbo.UpdatePayments2017_10 @PaymentDate, @PaymentId, 20000, 2;
		waitfor delay '0:00:00.050';

		select top 1 @PaymentDate = PaymentDate, @PaymentId = PaymentId
		from dbo.Payments2017_10
		where PaymentDate >= case when @I % 2 = 0 then '2017-01-01' else '2017-09-01' end and PaymentDate < '2017-06-01';
		exec dbo.DeletePayments2017_10 @PaymentDate, @PaymentId;
		waitfor delay '0:00:00.050';

		select @I = case when @I > 16383 then 1 else @I + 1 end;
		if @I % 10 = 0
			select @I as [@I];	
	end try
	begin catch
		waitfor delay '0:00:00.050';
	end catch
end
go 