/****************************************************************************/
/*      Everything You Always Wanted to Know about Data Partitioning        */
/*                         but Were AfraId to Ask                           */
/*                            PASS Summit 2017                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                                 Challenges                               */
/*                        Partial Database Availability                     */
/*                         Requires Enterprise Edition                      */
/****************************************************************************/

use master
go

alter database PartitionedDB set single_user with rollback immediate;
drop database PartitionedDB;
go

restore database PartitionedDB 
filegroup = 'Primary', filegroup = 'CurrentOrders', filegroup = 'RecentOrders'
from disk = N'C:\DB\Backup\PartitionedDB.bak' 
with file = 1,  
recovery, nounload,  partial, stats = 5;

select file_id, name, state_desc, physical_name
from PartitionedDB.sys.database_files
go

use PartitionedDB
go

if exists(select * from sys.procedures p join sys.schemas s on p.schema_id = s.schema_id where s.name = 'dbo' and p.name='GetOrderCount') drop proc dbo.GetOrderCount;
go

create proc dbo.GetOrderCount 
(
	@StartDate datetime2(0)
	,@StopDate datetime2(0)
)
as
	select count(*)
	from dbo.Orders
	where OrderDate >= @StartDate and OrderDate < @StopDate;
go

exec dbo.GetOrderCount @StartDate = '2017-09-15', @StopDate ='2017-11-01'
go

exec dbo.GetOrderCount @StartDate = '2017-08-15', @StopDate ='2017-11-01'
go

-- The problem is a bit more complicated:
select count(*)
from dbo.Orders2017
where OrderDate >= '2017-09-01';
go

declare
	@D datetime2(0) = '2017-09-01'

select count(*)
from dbo.Orders2017
where OrderDate >= @D;
go

select top 10 *
from dbo.Orders2017
order by OrderDate desc
go

-- This would never work
select count(*) 
from dbo.Orders
where WarehouseId = 10
go
